package com.carlo.aiwolf.bayes.player;

import java.util.*;

import org.aiwolf.client.base.player.AbstractMedium;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.carlo.aiwolf.bayes.trust.*;
import com.carlo.aiwolf.lib.info.*;
import com.carlo.aiwolf.lib.talk.COTalkCreator;

public class BayesMedium extends AbstractMedium {

private int readTalkNum=0;
	
	private GameInfoManager gameInfoMgr;
	private TrustListManager trustListManager;
	private COTalkCreator talkCreater;
	private GameBrain gameBrain;

	
	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);
		gameInfoMgr=new GameInfoManager(gameInfo,this.getMe());
		trustListManager=new TrustListManager(gameInfo.getAgentList(), this, gameInfoMgr);
		talkCreater=new COTalkCreator(this);
		gameBrain=new GameBrain(gameInfoMgr,trustListManager,talkCreater);
	}
	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
		readTalkList();
		gameInfoMgr.update(gameInfo);
		trustListManager.update();
		
		talkCreater.setVoteTarget(gameBrain.thinkVote());
		
	}

	@Override
	public void dayStart() {
		super.dayStart();
		gameInfoMgr.dayStart();
		readTalkNum=0;
		trustListManager.dayStart();
		
		talkCreater.dayStart(getMyJudgeList());
		
		//2日目になったらCO
		if(getDay()>1){
			talkCreater.doComingOut();
		}
		
	}

	@Override
	public void finish() {
		gameBrain.finish(getLatestDayGameInfo());
		//if(truthSeer!=null) System.out.println(","+this.getLatestDayGameInfo().getRoleMap().get(truthSeer));
	}


	@Override
	public String talk() {
		return talkCreater.talk();
	}
	
	@Override
	public Agent vote() {
		return talkCreater.getVoteTarget();
	}
	
	private void readTalkList(){
		List<Talk> talkList=this.getLatestDayGameInfo().getTalkList();
		for(int i=readTalkNum;i<talkList.size();i++){
			Talk talk=talkList.get(i);
			Utterance utterance=new Utterance(talk.getContent());
			switch (utterance.getTopic()){
			case COMINGOUT:
				switch (utterance.getRole()){
				case MEDIUM:
					break;
				default:
					break;
				}
				break;
			case DIVINED:
				break;
			case INQUESTED:
				break;
			default:
				break;
			}
			readTalkNum++;
		}
	}

}
