package com.carlo.aiwolf.bayes.trust;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;

import com.carlo.bayes.lib.WekaBayesManager;

import weka.classifiers.bayes.net.BIFReader;
import weka.classifiers.bayes.net.EditableBayesNet;
import weka.classifiers.bayes.net.MarginCalculator;
import weka.core.SerializedObject;

public class TestRead {

	public TestRead(){
		String fileName="xml/new_seer2_6.xml";
		
		try {

			
			BIFReader reader = new BIFReader();    
			try {

				
				
				InputStream is=this.getClass().getResourceAsStream(fileName);
				
				System.out.println(is);
				
				BufferedReader br
				   = new BufferedReader(
				   new InputStreamReader(is));
				 
				StringBuilder sb = new StringBuilder();
				 
				String line;
				 
				while ((line = br.readLine()) != null) {
				   sb.append(line);
				}
				 
				//System.out.println(sb.toString());
				 
				
				
				EditableBayesNet bayes=new EditableBayesNet(reader.processString(sb.toString()));
				
				//System.out.println(bayes.getMargin(0));
			
				
				MarginCalculator m_marginCalculator = new MarginCalculator();
				try {
					m_marginCalculator.calcMargins(bayes);
					SerializedObject so = new SerializedObject(m_marginCalculator);
					MarginCalculator m_marginCalculatorWithEvidence = (MarginCalculator) so.getObject();
					for (int iNode = 0; iNode < bayes.getNrOfNodes(); iNode++) {
						if (bayes.getEvidence(iNode) >= 0) {
							m_marginCalculatorWithEvidence.setEvidence(iNode, bayes.getEvidence(iNode));
						}
					}
					for (int iNode = 0; iNode < bayes.getNrOfNodes(); iNode++) {
						//System.out.println(iNode+":"+m_marginCalculatorWithEvidence.getMargin(iNode));
						bayes.setMargin(iNode, m_marginCalculatorWithEvidence.getMargin(iNode));
					}
					
					System.out.println(bayes.getMargin(1)[1]);
					
					WekaBayesManager mng= new WekaBayesManager(this.getClass().getResourceAsStream(fileName));
					
					mng.calcMargin();
					System.out.println("calc:"+mng.getMarginalProbability(0, 1));
					
					br.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
				
				
			} catch (Exception e) {
				e.printStackTrace();
			}
		}catch(Exception ex){
		}
		
	}
	public static void main(String args[]){
		TestRead read=new TestRead();
	}
}
