package com.carlo.aiwolf.log;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map.Entry;

import org.aiwolf.client.lib.TemplateTalkFactory.TalkType;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Status;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Vote;
import org.aiwolf.common.net.GameInfo;

import com.carlo.aiwolf.lib.info.CauseOfDeath;
import com.carlo.aiwolf.lib.info.GameInfoManager;

import jp.halfmoon.inaba.aiwolf.log.DayLog;
import jp.halfmoon.inaba.aiwolf.log.TalkLog;

/**
 * ログからの読み込みでAgentInformationMnagerを使えるようにするクラス
 * gameInfoを使わないようにメソッドをオーバーライド
 * 代わりにdayLogを使う
 * @author carlo
 *
 */

public class AgentInfoManagerForLog extends GameInfoManager {
	private DayLog dayLog;

	public AgentInfoManagerForLog(ArrayList<Agent> agentList){
		super(agentList);
	}
	public void dayStart(DayLog dayLog){
		readTalkNum=0;
		this.dayLog=dayLog;
		
		int day=dayLog.getDay();
		HashMap<Integer,Vote> voteMap=dayLog.getVoteList();
		
		Agent executedAgent=null;
		if(dayLog.getExecute()!=null){
			executedAgent=Agent.getAgent(dayLog.getExecute().getExecuteAgentNo());
		}
		
		Agent attackedAgent=null;
		//System.out.println(day+"日"+dayLog.getAttack());
		//if(dayLog.getAttack()!=null) System.out.println(dayLog.getAttack().getTargetAgentNo());
		if(dayLog.getAttack()!=null && dayLog.getAttack().isSuccess()){
			attackedAgent=Agent.getAgent(dayLog.getAttack().getTargetAgentNo());
			
			
		}
		//死亡者リストの追加
		
		
		//int yesterday=day-1;
		if(day>=1){ 
			deathInfo.addDeathData(day, executedAgent, attackedAgent);
			/*
			deadAgentMap.put(day,new HashMap<CauseOfDeath,Agent>());	
			deadAgentMap.get(day).put(CauseOfDeath.EXECUTED,executedAgent);
			deadAgentMap.get(day).put(CauseOfDeath.ATTACKED,attackedAgent);
			*/
		}
		if(day!=0){
			ArrayList<Vote> voteList=new ArrayList<Vote>();
			for (Entry<Integer, Vote> voteEntry : voteMap.entrySet()) {
				Vote vote=voteEntry.getValue();
				voteList.add(vote);
			}
			voteInfo.addList(voteList);
			//voteLists.add(voteList);
		}
	}
	/** agentが生存しているかどうか */
	public boolean isAlive(Agent agent){
		int agentIndex=agent.getAgentIdx();
		if(dayLog.getStatus().get(agentIndex).getStatus()==Status.ALIVE) return true;
		else return false;
	}
	public void update(ArrayList<TalkLog> talkLogs){
		for(int i=readTalkNum;i<talkLogs.size();i++){
			TalkLog talkLog=talkLogs.get(i);
			//ささやきは飛ばす
			if(talkLog.getTalkType()==TalkType.WHISPER) continue;
			//talk→talkLogにしてる
			Talk talk=new Talk(talkLog.getIdx(),talkLog.getDay(),Agent.getAgent(talkLog.getAgentNo()),talkLog.getContent());
			talkInfo.addTalk(talk);
			Utterance utterance=new Utterance(talk.getContent());
			Agent speaker=talk.getAgent();
			switch (utterance.getTopic()){
			case VOTE:
				//System.out.println(speaker+"-"+utterance.getTarget());
				break;
			case COMINGOUT:
				//村人COは聞かない
				coInfo.putCORole(speaker, utterance.getRole(),talk.getDay(),talk.getIdx(),true);
				break;
			case DIVINED:
				coInfo.putCORole(speaker, Role.SEER,talk.getDay(),talk.getIdx(),false);
				abilityInfo.addAbilityResult(speaker, utterance, talk.getDay());
				break;
			case INQUESTED:
				coInfo.putCORole(speaker, Role.MEDIUM,talk.getDay(),talk.getIdx(),false);
				abilityInfo.addAbilityResult(speaker, utterance, talk.getDay());
				break;
			case GUARDED:
				coInfo.putCORole(speaker, Role.BODYGUARD,talk.getDay(),talk.getIdx(),false);
				abilityInfo.addAbilityResult(speaker, utterance, talk.getDay());
				break;
			default:
				break;

			}
			readTalkNum++;
		}
	}

}
