package com.carlo.aiwolf.sample.player;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.base.player.AbstractPossessed;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.carlo.aiwolf.lib.ExRandom;
import com.carlo.aiwolf.lib.info.GameInfoManager;
import com.carlo.aiwolf.lib.talk.FakeCOTalkCreator;

public class SamplePossessed extends AbstractPossessed {
	protected GameInfoManager gameInfoMgr;
	private FakeCOTalkCreator talkCreator;
	private  ArrayList<Judge> fakeJudgeList;
	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);
		gameInfoMgr=new GameInfoManager(gameInfo,this.getMe());
		fakeJudgeList=new ArrayList<Judge>();
		talkCreator=new FakeCOTalkCreator(this);
		//占い師を騙る
		talkCreator.setFakeRole(Role.SEER);
	}
	@Override
	public void finish() {
		// TODO 自動生成されたメソッド・スタブ

	}
	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
		gameInfoMgr.update(gameInfo);
		talkCreator.setVoteTarget(thinkVote());
		
		talkCreator.doComingOut();
	}

	@Override
	public void dayStart() {
		gameInfoMgr.dayStart();
		
		//偽の結果作成
		if(getDay()>0){
			Agent target=ExRandom.select(gameInfoMgr.getAgentListExceptMe(true));
			//1/3の確率で人狼と判断
			Species species=ExRandom.checkHit(1, 3) ? Species.WEREWOLF :Species.HUMAN;
			//Species species=Species.WEREWOLF;
			Judge judge=new Judge(getDay(),getMe(),target,species);
			fakeJudgeList.add(judge);
		}
		
		
		talkCreator.dayStart(fakeJudgeList);
	}

	@Override
	public String talk() {
		return talkCreator.talk();
	}

	@Override
	public Agent vote() {
		return talkCreator.getVoteTarget();
		
	}
	
	private Agent thinkVote(){
		List<Agent> voteTargets;
		
		//占い師が4人以上でたらローラー
		if(gameInfoMgr.getCOInfo().getNumOfCOAgent(Role.SEER)>=4){
			voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(Role.SEER, true,true);
			if(voteTargets.size()>0) return voteTargets.get(0);
		}
		//霊能者が2人以上でたらローラー
		if(gameInfoMgr.getCOInfo().getNumOfCOAgent(Role.MEDIUM)>=2){
			voteTargets= gameInfoMgr.getCOInfo().getCOAgentList(Role.MEDIUM, true,true);
			if(voteTargets.size()>0) return voteTargets.get(0);
		}
		
		//3日までは非CO者からランダムに選択
		if(getDay()<4){
			voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(null, true,true);
			if(voteTargets.size()>0) return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
		}
		//上記条件に引っかからなければ全員からランダムに選択
		voteTargets=gameInfoMgr.getAgentListExceptMe(true);
		return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
	}



}
