package com.carlo.aiwolf.sample.player;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.base.player.AbstractSeer;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.carlo.aiwolf.lib.ExRandom;
import com.carlo.aiwolf.lib.info.GameInfoManager;
import com.carlo.aiwolf.lib.talk.COTalkCreator;

public class SampleSeer extends AbstractSeer {


	private GameInfoManager gameInfoMgr;

	/** 占ったエージェント */
	private ArrayList<Agent> myJudgeAgents;

	COTalkCreator talkCreator;

	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);
		gameInfoMgr=new GameInfoManager(gameInfo,this.getMe());
		myJudgeAgents=new ArrayList<Agent>();

		talkCreator=new COTalkCreator(this);
	}
	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
		gameInfoMgr.update(gameInfo);

		talkCreator.setVoteTarget(thinkVote());

	}

	@Override
	public void dayStart() {
		super.dayStart();
		gameInfoMgr.dayStart();
		talkCreator.dayStart(getMyJudgeList());

		if(this.getDay()>0){
			Judge yesterdayJudge=getMyJudgeList().get(getMyJudgeList().size()-1);
			myJudgeAgents.add(yesterdayJudge.getTarget());

			//if(yesterdayJudge.getResult()==Species.WEREWOLF) werewolfAgents.g
		}
		//System.out.println(getMyJudgeList());
		//agentInfo.printCoRoleMap();
		if(this.getDay()>0){
			talkCreator.doComingOut();
		}


	}

	@Override
	public void finish() {
	}


	@Override
	public String talk() {
		return talkCreator.talk();
	}

	@Override
	public Agent vote() {
		return talkCreator.getVoteTarget();
	}
	@Override
	public Agent divine() {
		//最初は非CO者から選ぶ
		List<Agent> candidates=gameInfoMgr.getCOInfo().getCOAgentList(null, true, true);
		if(getDay()<5){
			for(Agent agent:candidates){
				//自分が占っていない候補者を選ぶ
				if(myJudgeAgents.contains(agent)==false) return agent;
			}
		}

		//5日目以降はCO者も含める
		candidates=gameInfoMgr.getAgentListExceptMe(true);
		for(Agent agent:candidates){
			//自分が占っていない候補者を選ぶ
			if(myJudgeAgents.contains(agent)==false) return agent;
		}


		return ExRandom.select(gameInfoMgr.getAgentListExceptMe(true));
	}
	private Agent thinkVote(){
		List<Agent> voteTargets;
		
		//破綻者がいれば投票
		voteTargets=gameInfoMgr.getAbilityInfo().getNonVillagerTeamAgents();
		if(voteTargets.size()>0) return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
		
		//人狼を見つけたら人狼から選ぶ
		for(Judge judge:getMyJudgeList()){
			if(judge.getResult()==Species.WEREWOLF && gameInfoMgr.isAlive(judge.getTarget())){
				return judge.getTarget();
			}
		}

		//最初は非CO者から選ぶ
		voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(null, true, true);
		if(getDay()<5){
			for(Agent agent:voteTargets){
				//自分が占っていない候補者を選ぶ
				if(myJudgeAgents.contains(agent)==false) return agent;
			}
		}

		//5日目以降はCO者も含める
		voteTargets=gameInfoMgr.getAgentListExceptMe(true);
		for(Agent agent:voteTargets){
			//自分が占っていない候補者を選ぶ
			if(myJudgeAgents.contains(agent)==false) return agent;
		}

		//条件に引っかからなければ全員からランダム
		return ExRandom.select(gameInfoMgr.getAgentListExceptMe(true));
	}



}
