package com.carlo.aiwolf.sample.player;

import java.util.List;

import org.aiwolf.client.base.player.AbstractVillager;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.carlo.aiwolf.lib.ExRandom;
import com.carlo.aiwolf.lib.info.GameInfoManager;
import com.carlo.aiwolf.lib.talk.TalkCreator;
/**
 * GameInfoManagerとTalkCreaterの実装例エージェント
 * @author carlo
 *
 */
public class SampleVillager extends AbstractVillager {
	protected GameInfoManager gameInfoMgr;
	private TalkCreator talkCreator;
	
	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);
		gameInfoMgr=new GameInfoManager(gameInfo,this.getMe());
		talkCreator=new TalkCreator();
		
	}
	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
		gameInfoMgr.update(gameInfo);
		talkCreator.setVoteTarget(thinkVote());
	}

	@Override
	public void dayStart() {
		gameInfoMgr.dayStart();
		talkCreator.dayStart();
	}

	@Override
	public String talk() {
		return talkCreator.talk();
	}

	@Override
	public Agent vote() {
		return talkCreator.getVoteTarget();
		
	}
	
	private Agent thinkVote(){
		List<Agent> voteTargets;
		
		//破綻者がいれば投票
		voteTargets=gameInfoMgr.getAbilityInfo().getNonVillagerTeamAgents();
		if(voteTargets.size()>0) return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
		
		//占い師が4人以上でたらローラー
		if(gameInfoMgr.getCOInfo().getNumOfCOAgent(Role.SEER)>=4){
			voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(Role.SEER, true,true);
			if(voteTargets.size()>0) return voteTargets.get(0);
		}
		//霊能者が2人以上でたらローラー
		if(gameInfoMgr.getCOInfo().getNumOfCOAgent(Role.MEDIUM)>=2){
			voteTargets= gameInfoMgr.getCOInfo().getCOAgentList(Role.MEDIUM, true,true);
			if(voteTargets.size()>0) return voteTargets.get(0);
		}
		
		//3日までは非CO者からランダムに選択
		if(getDay()<4){
			voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(null, true,true);
			if(voteTargets.size()>0) return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
		}
		//上記条件に引っかからなければ全員からランダムに選択
		voteTargets=gameInfoMgr.getAgentListExceptMe(true);
		return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
	}
	@Override
	public void finish() {
		// TODO 自動生成されたメソッド・スタブ
		
	}


}
