package com.carlo.aiwolf.sample.player;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.base.player.AbstractWerewolf;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.carlo.aiwolf.lib.ExRandom;
import com.carlo.aiwolf.lib.info.GameInfoManager;
import com.carlo.aiwolf.lib.talk.*;

public class SampleWerewolf extends AbstractWerewolf{
	protected GameInfoManager gameInfoMgr;
	private WerewolfTalkCreator talkCreator;
	private  ArrayList<Judge> fakeJudgeList;
	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);
		gameInfoMgr=new GameInfoManager(gameInfo,this.getMe());
		fakeJudgeList=new ArrayList<Judge>();
		talkCreator=new WerewolfTalkCreator(this);
		
		
	}
	@Override
	public void finish() {
		// TODO 自動生成されたメソッド・スタブ

	}
	@Override
	public void update(GameInfo gameInfo){
		super.update(gameInfo);
		gameInfoMgr.update(gameInfo);
		talkCreator.setVoteTarget(thinkVote());
		//talkCreater.setWhisperVoteTarget(thinkVote());
		talkCreator.setAttackTarget(thinkAttack());
		
		talkCreator.setFakeRole(thinkFakeRole());
		//1日目になったらCO
		if(talkCreator.getComingoutRole()!=null && getDay()>0) talkCreator.doComingOut();
	}

	@Override
	public void dayStart() {
		gameInfoMgr.dayStart();
		
		//偽の結果作成
		if(getDay()>0){
			Agent target=ExRandom.select(gameInfoMgr.getAgentListExceptMe(true));
			Judge judge=new Judge(getDay(),getMe(),target,Species.WEREWOLF);
			fakeJudgeList.add(judge);
		}
		
		
		talkCreator.dayStart(fakeJudgeList);

	}

	@Override
	public String talk() {
		return talkCreator.talk();
	}

	@Override
	public Agent vote() {
		//System.out.println("size:"+gameInfoMgr.getTalkInfo().getTodaysTalkList(getMe()).size());
		//仲間の投票先にこっそり合わせる
		List<Agent> targets=gameInfoMgr.getWhisperInfo().searchTargetsMostVoted();
		if(targets.size()>0) return ExRandom.select(targets);
		
		//なければ普通に投票
		return talkCreator.getVoteTarget();
		
	}

	@Override
	public Agent attack() {
		return talkCreator.getAttackTarget();
	}
	@Override
	public String whisper() {
		// TODO 自動生成されたメソッド・スタブ
		return talkCreator.whisper();
	}
	private Role thinkFakeRole(){
		//誰も占いCOするつもりがないなら占いCO
		if(gameInfoMgr.getWhisperInfo().countNumOfFakeCO(Role.SEER)==0){
			return Role.SEER;
		}
		else{
			return Role.VILLAGER;
			//return null でも同じようなもの
		}
	}
	
	private Agent thinkAttack(){
		//仲間の襲撃先に合わせる
		List<Agent> targets=gameInfoMgr.getWhisperInfo().searchTargetsMostAttacked();
		if(targets.size()>0) return targets.get(0);
		//仲間を除いて選択
		targets.addAll(gameInfoMgr.getAgentListExceptMe(true));
		targets.removeAll(this.getWolfList());
		if(targets.size()>0) return targets.get(0);
		return this.getMe();
	}
	
	private Agent thinkVote(){
		//System.out.println("think vote");
		List<Agent> voteTargets;
		
		//占い師が4人以上でたらローラー
		if(gameInfoMgr.getCOInfo().getNumOfCOAgent(Role.SEER)>=4){
			voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(Role.SEER, true,true);
			if(voteTargets.size()>0) return voteTargets.get(0);
		}
		//霊能者が2人以上でたらローラー
		if(gameInfoMgr.getCOInfo().getNumOfCOAgent(Role.MEDIUM)>=2){
			voteTargets= gameInfoMgr.getCOInfo().getCOAgentList(Role.MEDIUM, true,true);
			if(voteTargets.size()>0) return voteTargets.get(0);
		}
		
		//3日までは非CO者からランダムに選択
		if(getDay()<4){
			voteTargets=gameInfoMgr.getCOInfo().getCOAgentList(null, true,true);
			voteTargets.removeAll(getWolfList());
			if(voteTargets.size()>0) return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
		}
		//上記条件に引っかからなければ全員からランダムに選択
		voteTargets=gameInfoMgr.getAgentListExceptMe(true);
		voteTargets.removeAll(getWolfList());
		if(voteTargets.size()>0) return ExRandom.select(voteTargets, talkCreator.getVoteTarget());
		else {
			return getMe();
		}
	}

}
