package com.carlo.aiwolf.sample.starter;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.aiwolf.client.base.player.AbstractRoleAssignPlayer;
import org.aiwolf.client.base.smpl.SampleRoleAssignPlayer;
import org.aiwolf.common.AIWolfAgentException;
import org.aiwolf.common.data.*;
import org.aiwolf.common.net.GameSetting;
import org.aiwolf.common.util.CalendarTools;
import org.aiwolf.common.util.Pair;
//import org.aiwolf.kajiClient.LearningPlayer.*;
import org.aiwolf.server.*;
import org.aiwolf.server.net.DirectConnectServer;
import org.aiwolf.server.net.GameServer;
import org.aiwolf.server.util.FileGameLogger;
import org.aiwolf.server.util.GameLogger;

import com.carlo.aiwolf.bayes.player.BayesPlayer;
import com.carlo.aiwolf.sample.player.SamplePlayer;
import com.yy.player.*;

import jp.halfmoon.inaba.aiwolf.strategyplayer.StrategyPlayer;

/**
 * RoleRequestで何回も回す
 * Bayesエージェントの性能テスト用
 * @author carlo
 *
 */

public class TestStarter {

	/**
	 * 参加エージェントの数
	 * 大会は15
	 * 10人で全役職あり
	 * 
	 * 結果ネットワーク生成に使ってる
	 */
	static protected int PLAYER_NUM = 15;


	public static void main(String[] args)  {

		try{

			//試行回数
			int gameNum=1;
			if(args.length>0){
				//第一引数：試行回数
				gameNum=Integer.parseInt(args[0]);
			}



			//対戦相手クラス
			ArrayList<Class> classes=new ArrayList<Class>();
			classes.add(Class.forName("org.aiwolf.client.base.smpl.SampleRoleAssignPlayer"));



			for(int i = 0;i<gameNum;i++){
				Map<Player, Role> playerMap = new HashMap<Player, Role>();

				for(int j=0;j<PLAYER_NUM-1;j++){

					//ランダムで追加
					int rnd=new Random().nextInt(classes.size());
					playerMap.put((Player) classes.get(rnd).newInstance(), null);
				}

				Player myPlayer=new SamplePlayer();
				playerMap.put(myPlayer, Role.WEREWOLF);

				GameServer gameServer = new DirectConnectServer(playerMap);
				GameSetting gameSetting = GameSetting.getDefaultGame(PLAYER_NUM);
				AIWolfGame game = new AIWolfGame(gameSetting, gameServer);
				//game.setShowConsoleLog(false);

				game.setRand(new Random(gameSetting.getRandomSeed()));
				game.start();



			}

		}
		catch(AIWolfAgentException e){
			e.printStackTrace();
		}
		catch(Exception e){
		}
	}
		
}
