package com.carlo.aiwolf.bayes.player;

import org.aiwolf.client.base.player.AbstractVillager;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import com.carlo.aiwolf.bayes.trust.*;
import com.carlo.aiwolf.lib.info.*;
import com.carlo.aiwolf.lib.talk.TalkCreator;
/**
 * @author carlo
 *
 */
public class BayesVillager extends AbstractVillager {
	
	protected GameInfoManager gameInfoMgr;
	protected TrustListManager trustListManager;
	
	private TalkCreator talkCreater;
	GameBrain gameBrain;
	@Override
	public void initialize(GameInfo gameInfo,GameSetting gameSetting){
		super.initialize(gameInfo, gameSetting);
		gameInfoMgr=new GameInfoManager(gameInfo,this.getMe());
		trustListManager=new TrustListManager(gameInfo.getAgentList(), this, gameInfoMgr);
		talkCreater=new TalkCreator();
		gameBrain=new GameBrain(gameInfoMgr,trustListManager,talkCreater);
	}
	@Override
	public void update(GameInfo gameInfo){
		//long start = System.currentTimeMillis();
		
		super.update(gameInfo);
		gameInfoMgr.update(gameInfo);
		trustListManager.update();
		talkCreater.setVoteTarget(gameBrain.thinkVote());
		
		//talkCreater.setEstimate(getMe(), Role.VILLAGER);
		
	}

	@Override
	public void dayStart() {
		//System.out.println();
		//long start = System.currentTimeMillis();
		
		gameInfoMgr.dayStart();
		trustListManager.dayStart();
		talkCreater.dayStart();
		
		//gameInfoMgr.getTalkInfo().printEstimateMap();
		//trustListManager.printTrustList();
		
		//if(getDay()>0) System.out.println(getDay()-1+":"+agentInfo.getVoteLists().get(getDay()-1));
		

	}

	@Override
	public void finish() {
		gameBrain.finish(getLatestDayGameInfo());
		//if(gameBrain.getTruthMedium()!=null) System.out.println(","+this.getLatestDayGameInfo().getRoleMap().get(gameBrain.getTruthMedium()));
		//if(agentInfo.isAlive(getMe())){
			//trustListManager.printTrustListForCreatingData(getLatestDayGameInfo());
		//}
		//trustListManager.printTrustList(getLatestDayGameInfo());
	}

	@Override
	public String talk() {
		return talkCreater.talk();
	}

	@Override
	public Agent vote() {
		return talkCreater.getVoteTarget();
		
	}
	


}
