package com.carlo.aiwolf.lib.talk;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.client.base.player.AbstractRole;
import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.*;

/**
 * CO・能力結果発言をしてくれる機能を追加したTalkCreater
 * @author info
 *
 */
public class COTalkCreator extends TalkCreator {
	protected boolean isComingOut;
	protected boolean isNeedToComingOut;
	protected ArrayList<Judge> myToldJudgeList;
	protected ArrayList<Judge> myJudgeList;
	
	protected ArrayList<Agent> myGuardList;
	protected int myToldGuardIdx;
	
	protected AbstractRole myRole;
	public COTalkCreator(AbstractRole myRole){
		isComingOut=false;
		isNeedToComingOut=false;
		myToldJudgeList=new ArrayList<Judge>();
		myJudgeList=new ArrayList<Judge>();
		
		myGuardList=new ArrayList<Agent>();
		myToldGuardIdx=0;
		
		this.myRole=myRole;
	}
	/** 非推奨。能力結果報告ができない。。 */
	@Deprecated
	public void dayStart(){
		super.dayStart();
	}
	/**
	 *  狩人用のdayStart
	 * @param guardTarget 昨夜護衛したターゲット <br>
	 * 真狩人ならgetLatestDayGameInfo().getGuardedAgent() を渡す
	 */
	public void dayStart(Agent guardTarget){
		super.dayStart();
		if(guardTarget!=null){
			myGuardList.add(guardTarget);
		}
	}
	/**
	 *  占い師と霊能者用のdayStart
	 * @param myJudgeList 占いもしくは霊能の結果リスト <br>
	 * 真占い・真霊能ならgetMyJudgeList()を渡す
	 */
	public void dayStart(List<Judge> myJudgeList){
		super.dayStart();
		if(myJudgeList!=null && myJudgeList.size()>0){
			this.myJudgeList.add(myJudgeList.get(myJudgeList.size()-1));
		}
	}
	/** このメソッドを呼ぶと、自分の発話が回ってきた時に自動的にカミングアウトを行う。<br>
	 * カミングアウト以降は結果報告を行うようになる。 */
	public void doComingOut(){
		isNeedToComingOut=true;
	}
	public boolean isComingOut(){
		return isComingOut;
	}
	/** しゃべる必要があることをしゃべる。
	 *  <br>CO>占い・霊能結果>スーパークラスのtalk で優先  */
	public String talk(){
		if(isNeedToComingOut && isComingOut==false){
			isComingOut=true;
			return TemplateTalkFactory.comingout(myRole.getMe(), getComingoutRole());
		}
		else if(isComingOut){
			if(getComingoutRole()==Role.SEER || getComingoutRole()==Role.MEDIUM){
				for(Judge judge:myJudgeList){
					//しゃべってないCO結果があるならしゃべる
					if(!myToldJudgeList.contains(judge)){
						myToldJudgeList.add(judge);
						if(getComingoutRole() ==Role.SEER) return TemplateTalkFactory.divined(judge.getTarget(), judge.getResult());
						else if(getComingoutRole()==Role.MEDIUM) return TemplateTalkFactory.inquested(judge.getTarget(), judge.getResult());
					}
				}
			}
			else if(getComingoutRole()==Role.BODYGUARD){
				for(int i=myToldGuardIdx;i<myGuardList.size();){
					myToldGuardIdx++;
					return TemplateTalkFactory.guarded(myGuardList.get(i));
				}
			}
		}
		
		return super.talk();
	}
	public Role getComingoutRole(){
		return myRole.getMyRole();
	}
	

}
